using System;
using System.Drawing;

namespace EsempioState.Step3
{
    partial class Parallelogramma
    {
        private abstract class Tipo
        {
            private readonly static TipoQuadrato _tipoQuadrato = new TipoQuadrato();
            private readonly static TipoRettangolo _tipoRettangolo = new TipoRettangolo();

            public abstract string Nome { get; }
            public abstract Color Colore { get; }
            public abstract int Timeout { get; }

            public static Tipo DeterminaTipo(Parallelogramma parallelogramma)
            {
                if (parallelogramma.Altezza == parallelogramma.Larghezza)
                    return _tipoQuadrato;
                else
                    return _tipoRettangolo;
            }

            private class TipoRettangolo : Tipo
            {
                public override string Nome
                {
                    get { return "Rettangolo"; }
                }

                public override Color Colore
                {
                    get { return Color.Red; }
                }

                public override int Timeout
                {
                    get { return 25; }
                }
            }

            private class TipoQuadrato : Tipo
            {
                public override string Nome
                {
                    get { return "Quadrato"; }
                }

                public override Color Colore
                {
                    get { return Color.Green; }
                }

                public override int Timeout
                {
                    get { return 1000; }
                }
            }
        }
    }
}